Index: debian/changelog
===================================================================
--- debian/changelog	(revision 4018)
+++ debian/changelog	(revision 4018)
@@ -0,0 +1,6 @@
+roaraudio (0.3~beta7-1) unstable; urgency=low
+
+  * Initial release.
+    Closes: #1234567
+
+ -- Patrick MatthÃ€i <pmatthaei@debian.org>  Thu, 01 Jul 2010 15:44:06 +0200
Index: debian/control
===================================================================
--- debian/control	(revision 3681)
+++ debian/control	(revision 4018)
@@ -1,6 +1,10 @@
 Source: roaraudio
 Priority: extra
-Maintainer: Michael Stapelberg <michael@stapelberg.de>
-Build-Depends: debhelper (>= 5), libdnet-dev, libesd0-dev, libao-dev, libfishsound1-dev, libvorbis-dev, libspeex-dev, libshout3-dev, libsndfile1-dev, liboggz1-dev | liboggz2-dev, libslp-dev, libpulse-dev, liby-dev, libartsc0-dev, libspeexdsp-dev | libspeex-dev (< 1.2), audacious-plugins-dev | xmms-dev
+Maintainer: Patrick MatthÃ€i <pmatthaei@debian.org>
+Build-Depends: debhelper (>= 5), libdnet-dev, libesd0-dev,
+ libfishsound1-dev, libvorbis-dev, libspeex-dev, libshout3-dev,
+ libsndfile1-dev, liboggz1-dev | liboggz2-dev, libslp-dev, libpulse-dev, liby-dev,
+ libartsc0-dev, libspeexdsp-dev | libspeex-dev (< 1.2),
+ audacious-plugins-dev | xmms-dev, libao-dev
 Standards-Version: 3.8.4
 Section: libs
@@ -42,5 +46,6 @@
 Architecture: any
 Provides: libsndio-dev
-Depends: ${shlibs:Depends}, ${misc:Depends}, libroar0 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libroar0 (= ${binary:Version}),
+ libroar-compat (= ${binary:Version})
 Description: header files and documentation for the roar audio libraries
  RoarAudio is a server for audio mixing. Its main purpose is to mix audio from
@@ -67,4 +72,6 @@
   libroarmidi: MIDI subsystem support library. It contains code to support
   the usage of the MIDI subsystem.
+ .
+ This package contains the development headers for the libroar library.
 
 Package: roaraudio-dbg
@@ -75,4 +82,29 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, libroar-dev (= ${binary:Version})
 Description: RoarAudio sound server for audio mixing (debugging symbols)
+ RoarAudio is a server for audio mixing. Its main purpose is to mix audio from
+ different clients before sending it to its outputs (for example a soundcard).
+ It is completely network transparent (UNIX sockets, TCP/IP, DECnet) and
+ supports many common codecs like Ogg Vorbis, Speex or FLAC.
+ .
+ This packet consists of the following libraries:
+ libroar: The RoarAudio main library. It contains code for talking to roard,
+ virtual IO functions useful not only for audio applications, memory
+ management functions like buffers, lists, stacks.
+ .
+ libroardsp: Digital Signal Processing library. It contains code to work with
+ PCM signals including simple filters, converters and code to work with some
+ (realtime) codecs.
+ .
+ libroareio: This is the RoarAudio Extended IO library. It contains code for
+ talking to extended IO. Currently it contains code to talk to soundcards
+ without roard. This is not meant to be used by other applications directly.
+ .
+ libroarlight: Light Control support library. It contains code to support
+ the usage of the light control subsystem.
+ .
+ libroarmidi: MIDI subsystem support library. It contains code to support
+ the usage of the MIDI subsystem.
+ .
+ This package contains the debugging symbols for roaraudio.
 
 Package: roaraudio
@@ -82,5 +114,5 @@
 Suggests: roaraudio-extra, libroar-compat, socat, roaraudio-plugin-libao
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: RoarAudio sound server for audio mixing
+Description: sound server for audio mixing
  RoarAudio is a server for audio mixing. Its main purpose is to mix audio from
  different clients before sending it to its outputs (for example a soundcard).
@@ -94,4 +126,9 @@
 Suggests: wget
 Description: extra utilities for roaraudio
+ RoarAudio is a server for audio mixing. Its main purpose is to mix audio from
+ different clients before sending it to its outputs (for example a soundcard).
+ It is completely network transparent (UNIX sockets, TCP/IP, DECnet) and
+ supports many common codecs like Ogg Vorbis, Speex or FLAC.
+ .
  Utilities which are not necessary for running roaraudio and which need
  extra dependencies are in this package (like roarshout and roarvorbis).
@@ -104,5 +141,6 @@
 Description: drop-in replacements for other sound libraries
  To get programs which use the EsounD (ESD), aRts, OpenBSD sndio, PulseAudio
- or YIFF API running, you can install this package and replace the appropriate libraries.
+ or YIFF API running, you can install this package and replace the appropriate
+ libraries.
 
 Package: roaraudio-plugin-xmms
Index: debian/libroar-dev.install
===================================================================
--- debian/libroar-dev.install	(revision 3648)
+++ debian/libroar-dev.install	(revision 4018)
@@ -2,8 +2,34 @@
 usr/bin/roarsocktypes
 usr/bin/roar-config
+usr/bin/roarfctest
+usr/bin/roarcatad
+usr/bin/roarsockconnect
+usr/bin/roarcatsendfile
+usr/bin/roarcat2sock
+usr/lib/libroar.so
+usr/lib/libroardsp.so
+usr/lib/libroarmidi.so
+usr/lib/libroarlight.so
+usr/lib/libroareio.so
+usr/lib/libroaross.so
+usr/lib/libroaresd.so
+usr/lib/libroarartsc.so
+usr/lib/libroarsndio.so
+usr/lib/libroaryiff.so
+usr/lib/libroarpulse-simple.so
+usr/lib/libroarpulse.so
 usr/include/*
+usr/lib/pkgconfig/libroarlight.pc
+usr/lib/pkgconfig/libroarmidi.pc
+usr/lib/pkgconfig/libroar.pc
+usr/lib/pkgconfig/libroareio.pc
+usr/lib/pkgconfig/libroardsp.pc
 usr/share/man/man1/roartypes.1
 usr/share/man/man1/roarsocktypes.1
 usr/share/man/man1/roar-config.1
+usr/share/man/man1/roarcat2sock.1
+usr/share/man/man1/roarcatad.1
+usr/share/man/man1/roarsockconnect.1
+usr/share/man/man1/roarcatsendfile.1
 usr/share/man/man3/*
 usr/share/man/man7/*
Index: debian/watch
===================================================================
--- debian/watch	(revision 4018)
+++ debian/watch	(revision 4018)
@@ -0,0 +1,2 @@
+version=3
+http://roaraudio.keep-cool.org/downloads.html dl/muroar-(.*)\.tar\.gz