Index: libroardsp/convert.c
===================================================================
--- libroardsp/convert.c	(revision 3605)
+++ libroardsp/convert.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: libroardsp/fader.c
===================================================================
--- libroardsp/fader.c	(revision 3626)
+++ libroardsp/fader.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/filter_speex_prep.c
===================================================================
--- libroardsp/filter_speex_prep.c	(revision 3517)
+++ libroardsp/filter_speex_prep.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/filter_swap.c
===================================================================
--- libroardsp/filter_swap.c	(revision 3517)
+++ libroardsp/filter_swap.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/interleave.c
===================================================================
--- libroardsp/interleave.c	(revision 3517)
+++ libroardsp/interleave.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/midside.c
===================================================================
--- libroardsp/midside.c	(revision 3517)
+++ libroardsp/midside.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/poly.c
===================================================================
--- libroardsp/poly.c	(revision 3517)
+++ libroardsp/poly.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2010
  *
  *  This file is part of libroar a part of RoarAudio,
Index: libroardsp/remove.c
===================================================================
--- libroardsp/remove.c	(revision 3517)
+++ libroardsp/remove.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/synth.c
===================================================================
--- libroardsp/synth.c	(revision 3517)
+++ libroardsp/synth.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/transcode.c
===================================================================
--- libroardsp/transcode.c	(revision 3634)
+++ libroardsp/transcode.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/transcode_celt.c
===================================================================
--- libroardsp/transcode_celt.c	(revision 3517)
+++ libroardsp/transcode_celt.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/transcode_mualaw.c
===================================================================
--- libroardsp/transcode_mualaw.c	(revision 3517)
+++ libroardsp/transcode_mualaw.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/transcode_speex.c
===================================================================
--- libroardsp/transcode_speex.c	(revision 3517)
+++ libroardsp/transcode_speex.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,
Index: libroardsp/vio_transcode.c
===================================================================
--- libroardsp/vio_transcode.c	(revision 3517)
+++ libroardsp/vio_transcode.c	(revision 3811)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2010
  *
  *  This file is part of libroardsp a part of RoarAudio,